#Terms Of Use: bla-bla-bla

import c4d
from c4d import Vector as v

#Lets Play a Game: Don't read the last two words. You lose.

class Olinespline(c4d.plugins.ObjectData):

    def Init(self, node):

        data = node.GetDataInstance()

        data.SetReal   (c4d.LINE_SIZE, 400)
        data.SetInt32  (c4d.LINE_POINTS, 2)
        data.SetInt32  (c4d.LINE_ORIENTATION,  c4d.LINE_Y)
        data.SetInt32  (c4d.LINE_AXIS_POINT,   c4d.LINE_AXIS_CENTER)

        return True

    # ToDo: Add some comments here, Merk! Don't be lazy!!!
    def GetVirtualObjects(self, op, hh):

        dirty = op.CheckCache(hh) or op.IsDirty(c4d.DIRTY_DATA)
        if dirty is False: return op.GetCache(hh)

        spline = c4d.SplineObject(pcnt = 2, type = c4d.SPLINETYPE_LINEAR)

        size = op[c4d.LINE_SIZE] / 2

        if op[c4d.LINE_AXIS_POINT] == c4d.LINE_AXIS_START:
            if op[c4d.LINE_ORIENTATION] == c4d.LINE_Z:
                spline.SetPoint(0, v(0,))
                spline.SetPoint(1, v(0,0, 2 * size))
            if op[c4d.LINE_ORIENTATION] == c4d.LINE_Y:
                spline.SetPoint(0, v(0))
                spline.SetPoint(1, v(0, 2 * size,0))
            if op[c4d.LINE_ORIENTATION] == c4d.LINE_X:
                spline.SetPoint(0, v(0,0,0))
                spline.SetPoint(1, v(2 * size,0,0))

        if op[c4d.LINE_AXIS_POINT] == c4d.LINE_AXIS_CENTER:
            if op[c4d.LINE_ORIENTATION] == c4d.LINE_Z:
                spline.SetPoint(0, v(0,0,-size))
                spline.SetPoint(1, v(0,0, size))
            if op[c4d.LINE_ORIENTATION] == c4d.LINE_Y:
                spline.SetPoint(0, v(0,-size,0))
                spline.SetPoint(1, v(0, size,0))
            if op[c4d.LINE_ORIENTATION] == c4d.LINE_X:
                spline.SetPoint(0, v(-size,0,0))
                spline.SetPoint(1, v(size,0,0))

        if op[c4d.LINE_AXIS_POINT] == c4d.LINE_AXIS_END:
            if op[c4d.LINE_ORIENTATION] == c4d.LINE_Z:
                spline.SetPoint(0, v(0,))
                spline.SetPoint(1, v(0,0, -2 * size))
            if op[c4d.LINE_ORIENTATION] == c4d.LINE_Y:
                spline.SetPoint(0, v(0))
                spline.SetPoint(1, v(0, -2 * size,0))
            if op[c4d.LINE_ORIENTATION] == c4d.LINE_X:
                spline.SetPoint(0, v(0,0,0))
                spline.SetPoint(1, v(-2 * size,0,0))


        spline[c4d.SPLINEOBJECT_TYPE]          = c4d.SPLINEOBJECT_INTERPOLATION_NONE
        spline[c4d.SPLINEOBJECT_CLOSED]        = False
        spline[c4d.SPLINEOBJECT_INTERPOLATION] = c4d.SPLINEOBJECT_INTERPOLATION_UNIFORM
        spline[c4d.SPLINEOBJECT_ANGLE]         = c4d.utils.Rad(90)
        spline[c4d.SPLINEOBJECT_MAXIMUMLENGTH] = 5
        spline[c4d.SPLINEOBJECT_SUB]           = op[c4d.LINE_POINTS] - 2

        output = c4d.utils.SendModelingCommand(command=c4d.MCOMMAND_CURRENTSTATETOOBJECT, list=[spline], doc=op.GetDocument())[0]

        op.CopyTagsTo(output,True,False,False)
        return output


if __name__ == "__main__":

    import os
    dir, file = os.path.split(__file__)
    fn = os.path.join(dir, "res", "icon.png")
    bmp = c4d.bitmaps.BaseBitmap()
    bmp.InitWith(fn)
    c4d.plugins.RegisterObjectPlugin(id = 1052763,
                                     str = "Line",
                                     g = Olinespline,
                                     description = "Olinespline",
                                     info = c4d.OBJECT_GENERATOR | c4d.OBJECT_ISSPLINE,
                                     icon = bmp)

# Line Object: Version 1.1